# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Balance(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'float',
        'balance_definition_id': 'str',
        'consumed_at': 'str',
        'contact_id': 'int',
        'created_at': 'str',
        'expires_at': 'str',
        'id': 'str',
        'loyalty_program_id': 'str',
        'organization_id': 'int'
    }

    attribute_map = {
        'amount': 'amount',
        'balance_definition_id': 'balanceDefinitionId',
        'consumed_at': 'consumedAt',
        'contact_id': 'contactId',
        'created_at': 'createdAt',
        'expires_at': 'expiresAt',
        'id': 'id',
        'loyalty_program_id': 'loyaltyProgramId',
        'organization_id': 'organizationId'
    }

    def __init__(self, amount=None, balance_definition_id=None, consumed_at=None, contact_id=None, created_at=None, expires_at=None, id=None, loyalty_program_id=None, organization_id=None):  # noqa: E501
        """Balance - a model defined in Swagger"""  # noqa: E501

        self._amount = None
        self._balance_definition_id = None
        self._consumed_at = None
        self._contact_id = None
        self._created_at = None
        self._expires_at = None
        self._id = None
        self._loyalty_program_id = None
        self._organization_id = None
        self.discriminator = None

        if amount is not None:
            self.amount = amount
        if balance_definition_id is not None:
            self.balance_definition_id = balance_definition_id
        if consumed_at is not None:
            self.consumed_at = consumed_at
        if contact_id is not None:
            self.contact_id = contact_id
        if created_at is not None:
            self.created_at = created_at
        if expires_at is not None:
            self.expires_at = expires_at
        if id is not None:
            self.id = id
        if loyalty_program_id is not None:
            self.loyalty_program_id = loyalty_program_id
        if organization_id is not None:
            self.organization_id = organization_id

    @property
    def amount(self):
        """Gets the amount of this Balance.  # noqa: E501

        The current amount available in the balance  # noqa: E501

        :return: The amount of this Balance.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this Balance.

        The current amount available in the balance  # noqa: E501

        :param amount: The amount of this Balance.  # noqa: E501
        :type: float
        """

        self._amount = amount

    @property
    def balance_definition_id(self):
        """Gets the balance_definition_id of this Balance.  # noqa: E501

        balance definition ID  # noqa: E501

        :return: The balance_definition_id of this Balance.  # noqa: E501
        :rtype: str
        """
        return self._balance_definition_id

    @balance_definition_id.setter
    def balance_definition_id(self, balance_definition_id):
        """Sets the balance_definition_id of this Balance.

        balance definition ID  # noqa: E501

        :param balance_definition_id: The balance_definition_id of this Balance.  # noqa: E501
        :type: str
        """

        self._balance_definition_id = balance_definition_id

    @property
    def consumed_at(self):
        """Gets the consumed_at of this Balance.  # noqa: E501

        Timestamp of when the balance was last consumed  # noqa: E501

        :return: The consumed_at of this Balance.  # noqa: E501
        :rtype: str
        """
        return self._consumed_at

    @consumed_at.setter
    def consumed_at(self, consumed_at):
        """Sets the consumed_at of this Balance.

        Timestamp of when the balance was last consumed  # noqa: E501

        :param consumed_at: The consumed_at of this Balance.  # noqa: E501
        :type: str
        """

        self._consumed_at = consumed_at

    @property
    def contact_id(self):
        """Gets the contact_id of this Balance.  # noqa: E501

        contact ID  # noqa: E501

        :return: The contact_id of this Balance.  # noqa: E501
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this Balance.

        contact ID  # noqa: E501

        :param contact_id: The contact_id of this Balance.  # noqa: E501
        :type: int
        """

        self._contact_id = contact_id

    @property
    def created_at(self):
        """Gets the created_at of this Balance.  # noqa: E501

        Timestamp of when the balance was created  # noqa: E501

        :return: The created_at of this Balance.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Balance.

        Timestamp of when the balance was created  # noqa: E501

        :param created_at: The created_at of this Balance.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def expires_at(self):
        """Gets the expires_at of this Balance.  # noqa: E501

        Expiration timestamp of the balance  # noqa: E501

        :return: The expires_at of this Balance.  # noqa: E501
        :rtype: str
        """
        return self._expires_at

    @expires_at.setter
    def expires_at(self, expires_at):
        """Sets the expires_at of this Balance.

        Expiration timestamp of the balance  # noqa: E501

        :param expires_at: The expires_at of this Balance.  # noqa: E501
        :type: str
        """

        self._expires_at = expires_at

    @property
    def id(self):
        """Gets the id of this Balance.  # noqa: E501

        Unique identifier for the balance  # noqa: E501

        :return: The id of this Balance.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Balance.

        Unique identifier for the balance  # noqa: E501

        :param id: The id of this Balance.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def loyalty_program_id(self):
        """Gets the loyalty_program_id of this Balance.  # noqa: E501

        loyalty program ID  # noqa: E501

        :return: The loyalty_program_id of this Balance.  # noqa: E501
        :rtype: str
        """
        return self._loyalty_program_id

    @loyalty_program_id.setter
    def loyalty_program_id(self, loyalty_program_id):
        """Sets the loyalty_program_id of this Balance.

        loyalty program ID  # noqa: E501

        :param loyalty_program_id: The loyalty_program_id of this Balance.  # noqa: E501
        :type: str
        """

        self._loyalty_program_id = loyalty_program_id

    @property
    def organization_id(self):
        """Gets the organization_id of this Balance.  # noqa: E501

        organization ID  # noqa: E501

        :return: The organization_id of this Balance.  # noqa: E501
        :rtype: int
        """
        return self._organization_id

    @organization_id.setter
    def organization_id(self, organization_id):
        """Sets the organization_id of this Balance.

        organization ID  # noqa: E501

        :param organization_id: The organization_id of this Balance.  # noqa: E501
        :type: int
        """

        self._organization_id = organization_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Balance, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Balance):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
