# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class BalanceDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'balance_availability_duration_modifier': 'str',
        'balance_availability_duration_unit': 'str',
        'balance_availability_duration_value': 'int',
        'balance_expiration_date': 'datetime',
        'balance_option_amount_overtaking_strategy': 'str',
        'balance_option_credit_rounding': 'str',
        'balance_option_debit_rounding': 'str',
        'created_at': 'datetime',
        'deleted_at': 'str',
        'description': 'str',
        'id': 'str',
        'image_ref': 'str',
        'max_amount': 'float',
        'max_credit_amount_limit': 'float',
        'max_debit_amount_limit': 'float',
        'meta': 'dict(str, object)',
        'min_amount': 'float',
        'name': 'str',
        'unit': 'str',
        'updated_at': 'str'
    }

    attribute_map = {
        'balance_availability_duration_modifier': 'balanceAvailabilityDurationModifier',
        'balance_availability_duration_unit': 'balanceAvailabilityDurationUnit',
        'balance_availability_duration_value': 'balanceAvailabilityDurationValue',
        'balance_expiration_date': 'balanceExpirationDate',
        'balance_option_amount_overtaking_strategy': 'balanceOptionAmountOvertakingStrategy',
        'balance_option_credit_rounding': 'balanceOptionCreditRounding',
        'balance_option_debit_rounding': 'balanceOptionDebitRounding',
        'created_at': 'createdAt',
        'deleted_at': 'deletedAt',
        'description': 'description',
        'id': 'id',
        'image_ref': 'imageRef',
        'max_amount': 'maxAmount',
        'max_credit_amount_limit': 'maxCreditAmountLimit',
        'max_debit_amount_limit': 'maxDebitAmountLimit',
        'meta': 'meta',
        'min_amount': 'minAmount',
        'name': 'name',
        'unit': 'unit',
        'updated_at': 'updatedAt'
    }

    def __init__(self, balance_availability_duration_modifier=None, balance_availability_duration_unit=None, balance_availability_duration_value=None, balance_expiration_date=None, balance_option_amount_overtaking_strategy=None, balance_option_credit_rounding=None, balance_option_debit_rounding=None, created_at=None, deleted_at=None, description=None, id=None, image_ref=None, max_amount=None, max_credit_amount_limit=None, max_debit_amount_limit=None, meta=None, min_amount=None, name=None, unit=None, updated_at=None):  # noqa: E501
        """BalanceDefinition - a model defined in Swagger"""  # noqa: E501

        self._balance_availability_duration_modifier = None
        self._balance_availability_duration_unit = None
        self._balance_availability_duration_value = None
        self._balance_expiration_date = None
        self._balance_option_amount_overtaking_strategy = None
        self._balance_option_credit_rounding = None
        self._balance_option_debit_rounding = None
        self._created_at = None
        self._deleted_at = None
        self._description = None
        self._id = None
        self._image_ref = None
        self._max_amount = None
        self._max_credit_amount_limit = None
        self._max_debit_amount_limit = None
        self._meta = None
        self._min_amount = None
        self._name = None
        self._unit = None
        self._updated_at = None
        self.discriminator = None

        if balance_availability_duration_modifier is not None:
            self.balance_availability_duration_modifier = balance_availability_duration_modifier
        if balance_availability_duration_unit is not None:
            self.balance_availability_duration_unit = balance_availability_duration_unit
        if balance_availability_duration_value is not None:
            self.balance_availability_duration_value = balance_availability_duration_value
        if balance_expiration_date is not None:
            self.balance_expiration_date = balance_expiration_date
        if balance_option_amount_overtaking_strategy is not None:
            self.balance_option_amount_overtaking_strategy = balance_option_amount_overtaking_strategy
        if balance_option_credit_rounding is not None:
            self.balance_option_credit_rounding = balance_option_credit_rounding
        if balance_option_debit_rounding is not None:
            self.balance_option_debit_rounding = balance_option_debit_rounding
        if created_at is not None:
            self.created_at = created_at
        if deleted_at is not None:
            self.deleted_at = deleted_at
        if description is not None:
            self.description = description
        if id is not None:
            self.id = id
        if image_ref is not None:
            self.image_ref = image_ref
        if max_amount is not None:
            self.max_amount = max_amount
        if max_credit_amount_limit is not None:
            self.max_credit_amount_limit = max_credit_amount_limit
        if max_debit_amount_limit is not None:
            self.max_debit_amount_limit = max_debit_amount_limit
        if meta is not None:
            self.meta = meta
        if min_amount is not None:
            self.min_amount = min_amount
        if name is not None:
            self.name = name
        if unit is not None:
            self.unit = unit
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def balance_availability_duration_modifier(self):
        """Gets the balance_availability_duration_modifier of this BalanceDefinition.  # noqa: E501

        startOfPeriod depicts the balancy expiry on start of day/week/month/year. endOfPeriod depicts the balancy expiry on end of day/week/month/year  # noqa: E501

        :return: The balance_availability_duration_modifier of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._balance_availability_duration_modifier

    @balance_availability_duration_modifier.setter
    def balance_availability_duration_modifier(self, balance_availability_duration_modifier):
        """Sets the balance_availability_duration_modifier of this BalanceDefinition.

        startOfPeriod depicts the balancy expiry on start of day/week/month/year. endOfPeriod depicts the balancy expiry on end of day/week/month/year  # noqa: E501

        :param balance_availability_duration_modifier: The balance_availability_duration_modifier of this BalanceDefinition.  # noqa: E501
        :type: str
        """
        allowed_values = ["startOfPeriod", "endOfPeriod", "noModification"]  # noqa: E501
        if balance_availability_duration_modifier not in allowed_values:
            raise ValueError(
                "Invalid value for `balance_availability_duration_modifier` ({0}), must be one of {1}"  # noqa: E501
                .format(balance_availability_duration_modifier, allowed_values)
            )

        self._balance_availability_duration_modifier = balance_availability_duration_modifier

    @property
    def balance_availability_duration_unit(self):
        """Gets the balance_availability_duration_unit of this BalanceDefinition.  # noqa: E501

        Unit of time for the balance's availability (e.g., day/week/month/year).  # noqa: E501

        :return: The balance_availability_duration_unit of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._balance_availability_duration_unit

    @balance_availability_duration_unit.setter
    def balance_availability_duration_unit(self, balance_availability_duration_unit):
        """Sets the balance_availability_duration_unit of this BalanceDefinition.

        Unit of time for the balance's availability (e.g., day/week/month/year).  # noqa: E501

        :param balance_availability_duration_unit: The balance_availability_duration_unit of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._balance_availability_duration_unit = balance_availability_duration_unit

    @property
    def balance_availability_duration_value(self):
        """Gets the balance_availability_duration_value of this BalanceDefinition.  # noqa: E501

        Number of days/weeks/month/year for balance expiry  # noqa: E501

        :return: The balance_availability_duration_value of this BalanceDefinition.  # noqa: E501
        :rtype: int
        """
        return self._balance_availability_duration_value

    @balance_availability_duration_value.setter
    def balance_availability_duration_value(self, balance_availability_duration_value):
        """Sets the balance_availability_duration_value of this BalanceDefinition.

        Number of days/weeks/month/year for balance expiry  # noqa: E501

        :param balance_availability_duration_value: The balance_availability_duration_value of this BalanceDefinition.  # noqa: E501
        :type: int
        """

        self._balance_availability_duration_value = balance_availability_duration_value

    @property
    def balance_expiration_date(self):
        """Gets the balance_expiration_date of this BalanceDefinition.  # noqa: E501

        Date when the balance expires and can no longer be used, in dd/mm format. The balance will be expired when this date appears next in the calendar and only one of balanceExpirationDate or balance availability fields can be used.  # noqa: E501

        :return: The balance_expiration_date of this BalanceDefinition.  # noqa: E501
        :rtype: datetime
        """
        return self._balance_expiration_date

    @balance_expiration_date.setter
    def balance_expiration_date(self, balance_expiration_date):
        """Sets the balance_expiration_date of this BalanceDefinition.

        Date when the balance expires and can no longer be used, in dd/mm format. The balance will be expired when this date appears next in the calendar and only one of balanceExpirationDate or balance availability fields can be used.  # noqa: E501

        :param balance_expiration_date: The balance_expiration_date of this BalanceDefinition.  # noqa: E501
        :type: datetime
        """

        self._balance_expiration_date = balance_expiration_date

    @property
    def balance_option_amount_overtaking_strategy(self):
        """Gets the balance_option_amount_overtaking_strategy of this BalanceDefinition.  # noqa: E501

        Partial enables partial credit of balance if maximum balance limit is reaching. Strict enables rejection of transaction if it will breach the max credit amount limit.  # noqa: E501

        :return: The balance_option_amount_overtaking_strategy of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._balance_option_amount_overtaking_strategy

    @balance_option_amount_overtaking_strategy.setter
    def balance_option_amount_overtaking_strategy(self, balance_option_amount_overtaking_strategy):
        """Sets the balance_option_amount_overtaking_strategy of this BalanceDefinition.

        Partial enables partial credit of balance if maximum balance limit is reaching. Strict enables rejection of transaction if it will breach the max credit amount limit.  # noqa: E501

        :param balance_option_amount_overtaking_strategy: The balance_option_amount_overtaking_strategy of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._balance_option_amount_overtaking_strategy = balance_option_amount_overtaking_strategy

    @property
    def balance_option_credit_rounding(self):
        """Gets the balance_option_credit_rounding of this BalanceDefinition.  # noqa: E501

        Rounding strategy for credit transactions.  # noqa: E501

        :return: The balance_option_credit_rounding of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._balance_option_credit_rounding

    @balance_option_credit_rounding.setter
    def balance_option_credit_rounding(self, balance_option_credit_rounding):
        """Sets the balance_option_credit_rounding of this BalanceDefinition.

        Rounding strategy for credit transactions.  # noqa: E501

        :param balance_option_credit_rounding: The balance_option_credit_rounding of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._balance_option_credit_rounding = balance_option_credit_rounding

    @property
    def balance_option_debit_rounding(self):
        """Gets the balance_option_debit_rounding of this BalanceDefinition.  # noqa: E501

        Rounding strategy for debit transactions.  # noqa: E501

        :return: The balance_option_debit_rounding of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._balance_option_debit_rounding

    @balance_option_debit_rounding.setter
    def balance_option_debit_rounding(self, balance_option_debit_rounding):
        """Sets the balance_option_debit_rounding of this BalanceDefinition.

        Rounding strategy for debit transactions.  # noqa: E501

        :param balance_option_debit_rounding: The balance_option_debit_rounding of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._balance_option_debit_rounding = balance_option_debit_rounding

    @property
    def created_at(self):
        """Gets the created_at of this BalanceDefinition.  # noqa: E501

        Timestamp of balance definition creation.  # noqa: E501

        :return: The created_at of this BalanceDefinition.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this BalanceDefinition.

        Timestamp of balance definition creation.  # noqa: E501

        :param created_at: The created_at of this BalanceDefinition.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def deleted_at(self):
        """Gets the deleted_at of this BalanceDefinition.  # noqa: E501

        Timestamp of balance definition deletion (nullable).  # noqa: E501

        :return: The deleted_at of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """Sets the deleted_at of this BalanceDefinition.

        Timestamp of balance definition deletion (nullable).  # noqa: E501

        :param deleted_at: The deleted_at of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._deleted_at = deleted_at

    @property
    def description(self):
        """Gets the description of this BalanceDefinition.  # noqa: E501

        Short description of the balance definition.  # noqa: E501

        :return: The description of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this BalanceDefinition.

        Short description of the balance definition.  # noqa: E501

        :param description: The description of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this BalanceDefinition.  # noqa: E501

        Unique identifier for the balance definition.  # noqa: E501

        :return: The id of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this BalanceDefinition.

        Unique identifier for the balance definition.  # noqa: E501

        :param id: The id of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def image_ref(self):
        """Gets the image_ref of this BalanceDefinition.  # noqa: E501

        Optional image reference URL.  # noqa: E501

        :return: The image_ref of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._image_ref

    @image_ref.setter
    def image_ref(self, image_ref):
        """Sets the image_ref of this BalanceDefinition.

        Optional image reference URL.  # noqa: E501

        :param image_ref: The image_ref of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._image_ref = image_ref

    @property
    def max_amount(self):
        """Gets the max_amount of this BalanceDefinition.  # noqa: E501

        Maximum allowable balance.  # noqa: E501

        :return: The max_amount of this BalanceDefinition.  # noqa: E501
        :rtype: float
        """
        return self._max_amount

    @max_amount.setter
    def max_amount(self, max_amount):
        """Sets the max_amount of this BalanceDefinition.

        Maximum allowable balance.  # noqa: E501

        :param max_amount: The max_amount of this BalanceDefinition.  # noqa: E501
        :type: float
        """

        self._max_amount = max_amount

    @property
    def max_credit_amount_limit(self):
        """Gets the max_credit_amount_limit of this BalanceDefinition.  # noqa: E501

        Max credit allowed per operation.  # noqa: E501

        :return: The max_credit_amount_limit of this BalanceDefinition.  # noqa: E501
        :rtype: float
        """
        return self._max_credit_amount_limit

    @max_credit_amount_limit.setter
    def max_credit_amount_limit(self, max_credit_amount_limit):
        """Sets the max_credit_amount_limit of this BalanceDefinition.

        Max credit allowed per operation.  # noqa: E501

        :param max_credit_amount_limit: The max_credit_amount_limit of this BalanceDefinition.  # noqa: E501
        :type: float
        """

        self._max_credit_amount_limit = max_credit_amount_limit

    @property
    def max_debit_amount_limit(self):
        """Gets the max_debit_amount_limit of this BalanceDefinition.  # noqa: E501

        Max debit allowed per operation.  # noqa: E501

        :return: The max_debit_amount_limit of this BalanceDefinition.  # noqa: E501
        :rtype: float
        """
        return self._max_debit_amount_limit

    @max_debit_amount_limit.setter
    def max_debit_amount_limit(self, max_debit_amount_limit):
        """Sets the max_debit_amount_limit of this BalanceDefinition.

        Max debit allowed per operation.  # noqa: E501

        :param max_debit_amount_limit: The max_debit_amount_limit of this BalanceDefinition.  # noqa: E501
        :type: float
        """

        self._max_debit_amount_limit = max_debit_amount_limit

    @property
    def meta(self):
        """Gets the meta of this BalanceDefinition.  # noqa: E501

        Additional metadata for the balance definition.  # noqa: E501

        :return: The meta of this BalanceDefinition.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this BalanceDefinition.

        Additional metadata for the balance definition.  # noqa: E501

        :param meta: The meta of this BalanceDefinition.  # noqa: E501
        :type: dict(str, object)
        """

        self._meta = meta

    @property
    def min_amount(self):
        """Gets the min_amount of this BalanceDefinition.  # noqa: E501

        Minimum allowable balance.  # noqa: E501

        :return: The min_amount of this BalanceDefinition.  # noqa: E501
        :rtype: float
        """
        return self._min_amount

    @min_amount.setter
    def min_amount(self, min_amount):
        """Sets the min_amount of this BalanceDefinition.

        Minimum allowable balance.  # noqa: E501

        :param min_amount: The min_amount of this BalanceDefinition.  # noqa: E501
        :type: float
        """

        self._min_amount = min_amount

    @property
    def name(self):
        """Gets the name of this BalanceDefinition.  # noqa: E501

        Name of the balance definition.  # noqa: E501

        :return: The name of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BalanceDefinition.

        Name of the balance definition.  # noqa: E501

        :param name: The name of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def unit(self):
        """Gets the unit of this BalanceDefinition.  # noqa: E501

        Unit of balance (e.g., points, currency).  # noqa: E501

        :return: The unit of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._unit

    @unit.setter
    def unit(self, unit):
        """Sets the unit of this BalanceDefinition.

        Unit of balance (e.g., points, currency).  # noqa: E501

        :param unit: The unit of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._unit = unit

    @property
    def updated_at(self):
        """Gets the updated_at of this BalanceDefinition.  # noqa: E501

        Timestamp of the last update.  # noqa: E501

        :return: The updated_at of this BalanceDefinition.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this BalanceDefinition.

        Timestamp of the last update.  # noqa: E501

        :param updated_at: The updated_at of this BalanceDefinition.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BalanceDefinition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BalanceDefinition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
