# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class FetchTemplatePreview(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'template_id': 'int',
        'email': 'str',
        'params': 'object'
    }

    attribute_map = {
        'template_id': 'templateId',
        'email': 'email',
        'params': 'params'
    }

    def __init__(self, template_id=None, email=None, params=None):  # noqa: E501
        """FetchTemplatePreview - a model defined in Swagger"""  # noqa: E501

        self._template_id = None
        self._email = None
        self._params = None
        self.discriminator = None

        self.template_id = template_id
        if email is not None:
            self.email = email
        if params is not None:
            self.params = params

    @property
    def template_id(self):
        """Gets the template_id of this FetchTemplatePreview.  # noqa: E501

        Id of the template.  # noqa: E501

        :return: The template_id of this FetchTemplatePreview.  # noqa: E501
        :rtype: int
        """
        return self._template_id

    @template_id.setter
    def template_id(self, template_id):
        """Sets the template_id of this FetchTemplatePreview.

        Id of the template.  # noqa: E501

        :param template_id: The template_id of this FetchTemplatePreview.  # noqa: E501
        :type: int
        """
        if template_id is None:
            raise ValueError("Invalid value for `template_id`, must not be `None`")  # noqa: E501

        self._template_id = template_id

    @property
    def email(self):
        """Gets the email of this FetchTemplatePreview.  # noqa: E501

        Email of the contact.(Required if params not provided)  # noqa: E501

        :return: The email of this FetchTemplatePreview.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this FetchTemplatePreview.

        Email of the contact.(Required if params not provided)  # noqa: E501

        :param email: The email of this FetchTemplatePreview.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def params(self):
        """Gets the params of this FetchTemplatePreview.  # noqa: E501

        Key-value pairs of dynamic parameters for template rendering.(Required if email not provided) For example, {\"Firstname\":\"John\", \"Lastname\":\"Doe\"}.  # noqa: E501

        :return: The params of this FetchTemplatePreview.  # noqa: E501
        :rtype: object
        """
        return self._params

    @params.setter
    def params(self, params):
        """Sets the params of this FetchTemplatePreview.

        Key-value pairs of dynamic parameters for template rendering.(Required if email not provided) For example, {\"Firstname\":\"John\", \"Lastname\":\"Doe\"}.  # noqa: E501

        :param params: The params of this FetchTemplatePreview.  # noqa: E501
        :type: object
        """

        self._params = params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FetchTemplatePreview, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FetchTemplatePreview):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
