# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MainProduct(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created_at': 'str',
        'image_ref': 'str',
        'product_id': 'str',
        'value': 'str'
    }

    attribute_map = {
        'created_at': 'createdAt',
        'image_ref': 'imageRef',
        'product_id': 'productId',
        'value': 'value'
    }

    def __init__(self, created_at=None, image_ref=None, product_id=None, value=None):  # noqa: E501
        """MainProduct - a model defined in Swagger"""  # noqa: E501

        self._created_at = None
        self._image_ref = None
        self._product_id = None
        self._value = None
        self.discriminator = None

        if created_at is not None:
            self.created_at = created_at
        if image_ref is not None:
            self.image_ref = image_ref
        if product_id is not None:
            self.product_id = product_id
        if value is not None:
            self.value = value

    @property
    def created_at(self):
        """Gets the created_at of this MainProduct.  # noqa: E501

        Timestamp when the product was created  # noqa: E501

        :return: The created_at of this MainProduct.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this MainProduct.

        Timestamp when the product was created  # noqa: E501

        :param created_at: The created_at of this MainProduct.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def image_ref(self):
        """Gets the image_ref of this MainProduct.  # noqa: E501

        URL of the product image  # noqa: E501

        :return: The image_ref of this MainProduct.  # noqa: E501
        :rtype: str
        """
        return self._image_ref

    @image_ref.setter
    def image_ref(self, image_ref):
        """Sets the image_ref of this MainProduct.

        URL of the product image  # noqa: E501

        :param image_ref: The image_ref of this MainProduct.  # noqa: E501
        :type: str
        """

        self._image_ref = image_ref

    @property
    def product_id(self):
        """Gets the product_id of this MainProduct.  # noqa: E501

        Unique identifier for the product  # noqa: E501

        :return: The product_id of this MainProduct.  # noqa: E501
        :rtype: str
        """
        return self._product_id

    @product_id.setter
    def product_id(self, product_id):
        """Sets the product_id of this MainProduct.

        Unique identifier for the product  # noqa: E501

        :param product_id: The product_id of this MainProduct.  # noqa: E501
        :type: str
        """

        self._product_id = product_id

    @property
    def value(self):
        """Gets the value of this MainProduct.  # noqa: E501

        string  # noqa: E501

        :return: The value of this MainProduct.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this MainProduct.

        string  # noqa: E501

        :param value: The value of this MainProduct.  # noqa: E501
        :type: str
        """

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MainProduct, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MainProduct):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
