# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MainRedeem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cancelled_at': 'datetime',
        'completed_at': 'datetime',
        'contact_id': 'int',
        'created_at': 'datetime',
        'debit_transaction_id': 'str',
        'expires_at': 'datetime',
        'id': 'str',
        'loyalty_program_id': 'str',
        'meta': 'dict(str, object)',
        'reject_reason': 'str',
        'rejected_at': 'datetime',
        'reward_attribution_id': 'str',
        'status': 'str',
        'updated_at': 'datetime'
    }

    attribute_map = {
        'cancelled_at': 'cancelledAt',
        'completed_at': 'completedAt',
        'contact_id': 'contactId',
        'created_at': 'createdAt',
        'debit_transaction_id': 'debitTransactionId',
        'expires_at': 'expiresAt',
        'id': 'id',
        'loyalty_program_id': 'loyaltyProgramId',
        'meta': 'meta',
        'reject_reason': 'rejectReason',
        'rejected_at': 'rejectedAt',
        'reward_attribution_id': 'rewardAttributionId',
        'status': 'status',
        'updated_at': 'updatedAt'
    }

    def __init__(self, cancelled_at=None, completed_at=None, contact_id=None, created_at=None, debit_transaction_id=None, expires_at=None, id=None, loyalty_program_id=None, meta=None, reject_reason=None, rejected_at=None, reward_attribution_id=None, status=None, updated_at=None):  # noqa: E501
        """MainRedeem - a model defined in Swagger"""  # noqa: E501

        self._cancelled_at = None
        self._completed_at = None
        self._contact_id = None
        self._created_at = None
        self._debit_transaction_id = None
        self._expires_at = None
        self._id = None
        self._loyalty_program_id = None
        self._meta = None
        self._reject_reason = None
        self._rejected_at = None
        self._reward_attribution_id = None
        self._status = None
        self._updated_at = None
        self.discriminator = None

        if cancelled_at is not None:
            self.cancelled_at = cancelled_at
        if completed_at is not None:
            self.completed_at = completed_at
        if contact_id is not None:
            self.contact_id = contact_id
        if created_at is not None:
            self.created_at = created_at
        if debit_transaction_id is not None:
            self.debit_transaction_id = debit_transaction_id
        if expires_at is not None:
            self.expires_at = expires_at
        if id is not None:
            self.id = id
        if loyalty_program_id is not None:
            self.loyalty_program_id = loyalty_program_id
        if meta is not None:
            self.meta = meta
        if reject_reason is not None:
            self.reject_reason = reject_reason
        if rejected_at is not None:
            self.rejected_at = rejected_at
        if reward_attribution_id is not None:
            self.reward_attribution_id = reward_attribution_id
        if status is not None:
            self.status = status
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def cancelled_at(self):
        """Gets the cancelled_at of this MainRedeem.  # noqa: E501

        Timestamp when the redemption was cancelled  # noqa: E501

        :return: The cancelled_at of this MainRedeem.  # noqa: E501
        :rtype: datetime
        """
        return self._cancelled_at

    @cancelled_at.setter
    def cancelled_at(self, cancelled_at):
        """Sets the cancelled_at of this MainRedeem.

        Timestamp when the redemption was cancelled  # noqa: E501

        :param cancelled_at: The cancelled_at of this MainRedeem.  # noqa: E501
        :type: datetime
        """

        self._cancelled_at = cancelled_at

    @property
    def completed_at(self):
        """Gets the completed_at of this MainRedeem.  # noqa: E501

        Timestamp when the redemption was completed  # noqa: E501

        :return: The completed_at of this MainRedeem.  # noqa: E501
        :rtype: datetime
        """
        return self._completed_at

    @completed_at.setter
    def completed_at(self, completed_at):
        """Sets the completed_at of this MainRedeem.

        Timestamp when the redemption was completed  # noqa: E501

        :param completed_at: The completed_at of this MainRedeem.  # noqa: E501
        :type: datetime
        """

        self._completed_at = completed_at

    @property
    def contact_id(self):
        """Gets the contact_id of this MainRedeem.  # noqa: E501

        Unique identifier for the contact  # noqa: E501

        :return: The contact_id of this MainRedeem.  # noqa: E501
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this MainRedeem.

        Unique identifier for the contact  # noqa: E501

        :param contact_id: The contact_id of this MainRedeem.  # noqa: E501
        :type: int
        """

        self._contact_id = contact_id

    @property
    def created_at(self):
        """Gets the created_at of this MainRedeem.  # noqa: E501

        Timestamp when the redemption was created  # noqa: E501

        :return: The created_at of this MainRedeem.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this MainRedeem.

        Timestamp when the redemption was created  # noqa: E501

        :param created_at: The created_at of this MainRedeem.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def debit_transaction_id(self):
        """Gets the debit_transaction_id of this MainRedeem.  # noqa: E501

        Unique identifier for the debit transaction  # noqa: E501

        :return: The debit_transaction_id of this MainRedeem.  # noqa: E501
        :rtype: str
        """
        return self._debit_transaction_id

    @debit_transaction_id.setter
    def debit_transaction_id(self, debit_transaction_id):
        """Sets the debit_transaction_id of this MainRedeem.

        Unique identifier for the debit transaction  # noqa: E501

        :param debit_transaction_id: The debit_transaction_id of this MainRedeem.  # noqa: E501
        :type: str
        """

        self._debit_transaction_id = debit_transaction_id

    @property
    def expires_at(self):
        """Gets the expires_at of this MainRedeem.  # noqa: E501

        Timestamp when the redemption expires  # noqa: E501

        :return: The expires_at of this MainRedeem.  # noqa: E501
        :rtype: datetime
        """
        return self._expires_at

    @expires_at.setter
    def expires_at(self, expires_at):
        """Sets the expires_at of this MainRedeem.

        Timestamp when the redemption expires  # noqa: E501

        :param expires_at: The expires_at of this MainRedeem.  # noqa: E501
        :type: datetime
        """

        self._expires_at = expires_at

    @property
    def id(self):
        """Gets the id of this MainRedeem.  # noqa: E501

        Unique identifier for the redemption  # noqa: E501

        :return: The id of this MainRedeem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MainRedeem.

        Unique identifier for the redemption  # noqa: E501

        :param id: The id of this MainRedeem.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def loyalty_program_id(self):
        """Gets the loyalty_program_id of this MainRedeem.  # noqa: E501

        Unique identifier for the loyalty program  # noqa: E501

        :return: The loyalty_program_id of this MainRedeem.  # noqa: E501
        :rtype: str
        """
        return self._loyalty_program_id

    @loyalty_program_id.setter
    def loyalty_program_id(self, loyalty_program_id):
        """Sets the loyalty_program_id of this MainRedeem.

        Unique identifier for the loyalty program  # noqa: E501

        :param loyalty_program_id: The loyalty_program_id of this MainRedeem.  # noqa: E501
        :type: str
        """

        self._loyalty_program_id = loyalty_program_id

    @property
    def meta(self):
        """Gets the meta of this MainRedeem.  # noqa: E501

        Additional metadata associated with the redemption  # noqa: E501

        :return: The meta of this MainRedeem.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this MainRedeem.

        Additional metadata associated with the redemption  # noqa: E501

        :param meta: The meta of this MainRedeem.  # noqa: E501
        :type: dict(str, object)
        """

        self._meta = meta

    @property
    def reject_reason(self):
        """Gets the reject_reason of this MainRedeem.  # noqa: E501

        Reason for rejection if the redemption was rejected  # noqa: E501

        :return: The reject_reason of this MainRedeem.  # noqa: E501
        :rtype: str
        """
        return self._reject_reason

    @reject_reason.setter
    def reject_reason(self, reject_reason):
        """Sets the reject_reason of this MainRedeem.

        Reason for rejection if the redemption was rejected  # noqa: E501

        :param reject_reason: The reject_reason of this MainRedeem.  # noqa: E501
        :type: str
        """

        self._reject_reason = reject_reason

    @property
    def rejected_at(self):
        """Gets the rejected_at of this MainRedeem.  # noqa: E501

        Timestamp when the redemption was rejected  # noqa: E501

        :return: The rejected_at of this MainRedeem.  # noqa: E501
        :rtype: datetime
        """
        return self._rejected_at

    @rejected_at.setter
    def rejected_at(self, rejected_at):
        """Sets the rejected_at of this MainRedeem.

        Timestamp when the redemption was rejected  # noqa: E501

        :param rejected_at: The rejected_at of this MainRedeem.  # noqa: E501
        :type: datetime
        """

        self._rejected_at = rejected_at

    @property
    def reward_attribution_id(self):
        """Gets the reward_attribution_id of this MainRedeem.  # noqa: E501

        Unique identifier for the reward attribution  # noqa: E501

        :return: The reward_attribution_id of this MainRedeem.  # noqa: E501
        :rtype: str
        """
        return self._reward_attribution_id

    @reward_attribution_id.setter
    def reward_attribution_id(self, reward_attribution_id):
        """Sets the reward_attribution_id of this MainRedeem.

        Unique identifier for the reward attribution  # noqa: E501

        :param reward_attribution_id: The reward_attribution_id of this MainRedeem.  # noqa: E501
        :type: str
        """

        self._reward_attribution_id = reward_attribution_id

    @property
    def status(self):
        """Gets the status of this MainRedeem.  # noqa: E501

        Current status of the redemption  # noqa: E501

        :return: The status of this MainRedeem.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this MainRedeem.

        Current status of the redemption  # noqa: E501

        :param status: The status of this MainRedeem.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def updated_at(self):
        """Gets the updated_at of this MainRedeem.  # noqa: E501

        Timestamp when the redemption was last updated  # noqa: E501

        :return: The updated_at of this MainRedeem.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this MainRedeem.

        Timestamp when the redemption was last updated  # noqa: E501

        :param updated_at: The updated_at of this MainRedeem.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MainRedeem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MainRedeem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
