# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MainRewardAttribution(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'value': 'float',
        'code': 'str',
        'consumed_at': 'str',
        'contact_id': 'int',
        'created_at': 'datetime',
        'expiration_date': 'datetime',
        'id': 'str',
        'loyalty_program_id': 'str',
        'meta': 'dict(str, object)',
        'reward_id': 'str',
        'updated_at': 'datetime'
    }

    attribute_map = {
        'value': 'value',
        'code': 'code',
        'consumed_at': 'consumedAt',
        'contact_id': 'contactId',
        'created_at': 'createdAt',
        'expiration_date': 'expirationDate',
        'id': 'id',
        'loyalty_program_id': 'loyaltyProgramId',
        'meta': 'meta',
        'reward_id': 'rewardId',
        'updated_at': 'updatedAt'
    }

    def __init__(self, value=None, code=None, consumed_at=None, contact_id=None, created_at=None, expiration_date=None, id=None, loyalty_program_id=None, meta=None, reward_id=None, updated_at=None):  # noqa: E501
        """MainRewardAttribution - a model defined in Swagger"""  # noqa: E501

        self._value = None
        self._code = None
        self._consumed_at = None
        self._contact_id = None
        self._created_at = None
        self._expiration_date = None
        self._id = None
        self._loyalty_program_id = None
        self._meta = None
        self._reward_id = None
        self._updated_at = None
        self.discriminator = None

        if value is not None:
            self.value = value
        if code is not None:
            self.code = code
        if consumed_at is not None:
            self.consumed_at = consumed_at
        if contact_id is not None:
            self.contact_id = contact_id
        if created_at is not None:
            self.created_at = created_at
        if expiration_date is not None:
            self.expiration_date = expiration_date
        if id is not None:
            self.id = id
        if loyalty_program_id is not None:
            self.loyalty_program_id = loyalty_program_id
        if meta is not None:
            self.meta = meta
        if reward_id is not None:
            self.reward_id = reward_id
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def value(self):
        """Gets the value of this MainRewardAttribution.  # noqa: E501

        Value of the selected reward config  # noqa: E501

        :return: The value of this MainRewardAttribution.  # noqa: E501
        :rtype: float
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this MainRewardAttribution.

        Value of the selected reward config  # noqa: E501

        :param value: The value of this MainRewardAttribution.  # noqa: E501
        :type: float
        """

        self._value = value

    @property
    def code(self):
        """Gets the code of this MainRewardAttribution.  # noqa: E501

        Generated code  # noqa: E501

        :return: The code of this MainRewardAttribution.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this MainRewardAttribution.

        Generated code  # noqa: E501

        :param code: The code of this MainRewardAttribution.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def consumed_at(self):
        """Gets the consumed_at of this MainRewardAttribution.  # noqa: E501

        Timestamp for when this reward was consumed  # noqa: E501

        :return: The consumed_at of this MainRewardAttribution.  # noqa: E501
        :rtype: str
        """
        return self._consumed_at

    @consumed_at.setter
    def consumed_at(self, consumed_at):
        """Sets the consumed_at of this MainRewardAttribution.

        Timestamp for when this reward was consumed  # noqa: E501

        :param consumed_at: The consumed_at of this MainRewardAttribution.  # noqa: E501
        :type: str
        """

        self._consumed_at = consumed_at

    @property
    def contact_id(self):
        """Gets the contact_id of this MainRewardAttribution.  # noqa: E501

        Id of the contact that attributed the reward  # noqa: E501

        :return: The contact_id of this MainRewardAttribution.  # noqa: E501
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this MainRewardAttribution.

        Id of the contact that attributed the reward  # noqa: E501

        :param contact_id: The contact_id of this MainRewardAttribution.  # noqa: E501
        :type: int
        """

        self._contact_id = contact_id

    @property
    def created_at(self):
        """Gets the created_at of this MainRewardAttribution.  # noqa: E501

        Timestamp for when this reward was created  # noqa: E501

        :return: The created_at of this MainRewardAttribution.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this MainRewardAttribution.

        Timestamp for when this reward was created  # noqa: E501

        :param created_at: The created_at of this MainRewardAttribution.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def expiration_date(self):
        """Gets the expiration_date of this MainRewardAttribution.  # noqa: E501

        Expiration date of the reward  # noqa: E501

        :return: The expiration_date of this MainRewardAttribution.  # noqa: E501
        :rtype: datetime
        """
        return self._expiration_date

    @expiration_date.setter
    def expiration_date(self, expiration_date):
        """Sets the expiration_date of this MainRewardAttribution.

        Expiration date of the reward  # noqa: E501

        :param expiration_date: The expiration_date of this MainRewardAttribution.  # noqa: E501
        :type: datetime
        """

        self._expiration_date = expiration_date

    @property
    def id(self):
        """Gets the id of this MainRewardAttribution.  # noqa: E501

        Unique idenitifier  # noqa: E501

        :return: The id of this MainRewardAttribution.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MainRewardAttribution.

        Unique idenitifier  # noqa: E501

        :param id: The id of this MainRewardAttribution.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def loyalty_program_id(self):
        """Gets the loyalty_program_id of this MainRewardAttribution.  # noqa: E501

        Loyalty Program Id to which attributed reward belongs  # noqa: E501

        :return: The loyalty_program_id of this MainRewardAttribution.  # noqa: E501
        :rtype: str
        """
        return self._loyalty_program_id

    @loyalty_program_id.setter
    def loyalty_program_id(self, loyalty_program_id):
        """Sets the loyalty_program_id of this MainRewardAttribution.

        Loyalty Program Id to which attributed reward belongs  # noqa: E501

        :param loyalty_program_id: The loyalty_program_id of this MainRewardAttribution.  # noqa: E501
        :type: str
        """

        self._loyalty_program_id = loyalty_program_id

    @property
    def meta(self):
        """Gets the meta of this MainRewardAttribution.  # noqa: E501

        Additional data to define the reward  # noqa: E501

        :return: The meta of this MainRewardAttribution.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this MainRewardAttribution.

        Additional data to define the reward  # noqa: E501

        :param meta: The meta of this MainRewardAttribution.  # noqa: E501
        :type: dict(str, object)
        """

        self._meta = meta

    @property
    def reward_id(self):
        """Gets the reward_id of this MainRewardAttribution.  # noqa: E501

        Unique identifier for the reward  # noqa: E501

        :return: The reward_id of this MainRewardAttribution.  # noqa: E501
        :rtype: str
        """
        return self._reward_id

    @reward_id.setter
    def reward_id(self, reward_id):
        """Sets the reward_id of this MainRewardAttribution.

        Unique identifier for the reward  # noqa: E501

        :param reward_id: The reward_id of this MainRewardAttribution.  # noqa: E501
        :type: str
        """

        self._reward_id = reward_id

    @property
    def updated_at(self):
        """Gets the updated_at of this MainRewardAttribution.  # noqa: E501

        Timestamp for when this reward was updated  # noqa: E501

        :return: The updated_at of this MainRewardAttribution.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this MainRewardAttribution.

        Timestamp for when this reward was updated  # noqa: E501

        :param updated_at: The updated_at of this MainRewardAttribution.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MainRewardAttribution, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MainRewardAttribution):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
