# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SubAccountUpdatePlanRequestCredits(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email': 'int',
        'sms': 'float',
        'wp_subscribers': 'int',
        'external_feeds': 'float',
        'whatsapp': 'float'
    }

    attribute_map = {
        'email': 'email',
        'sms': 'sms',
        'wp_subscribers': 'wpSubscribers',
        'external_feeds': 'externalFeeds',
        'whatsapp': 'whatsapp'
    }

    def __init__(self, email=None, sms=None, wp_subscribers=None, external_feeds=None, whatsapp=None):  # noqa: E501
        """SubAccountUpdatePlanRequestCredits - a model defined in Swagger"""  # noqa: E501

        self._email = None
        self._sms = None
        self._wp_subscribers = None
        self._external_feeds = None
        self._whatsapp = None
        self.discriminator = None

        if email is not None:
            self.email = email
        if sms is not None:
            self.sms = sms
        if wp_subscribers is not None:
            self.wp_subscribers = wp_subscribers
        if external_feeds is not None:
            self.external_feeds = external_feeds
        if whatsapp is not None:
            self.whatsapp = whatsapp

    @property
    def email(self):
        """Gets the email of this SubAccountUpdatePlanRequestCredits.  # noqa: E501

        Number of email credits | Pass the value -1 for unlimited emails in ENTv2 only  # noqa: E501

        :return: The email of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :rtype: int
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this SubAccountUpdatePlanRequestCredits.

        Number of email credits | Pass the value -1 for unlimited emails in ENTv2 only  # noqa: E501

        :param email: The email of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :type: int
        """

        self._email = email

    @property
    def sms(self):
        """Gets the sms of this SubAccountUpdatePlanRequestCredits.  # noqa: E501

        Number of SMS credits | Pass the value -1 for unlimited SMS in ENTv2 only  # noqa: E501

        :return: The sms of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :rtype: float
        """
        return self._sms

    @sms.setter
    def sms(self, sms):
        """Sets the sms of this SubAccountUpdatePlanRequestCredits.

        Number of SMS credits | Pass the value -1 for unlimited SMS in ENTv2 only  # noqa: E501

        :param sms: The sms of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :type: float
        """

        self._sms = sms

    @property
    def wp_subscribers(self):
        """Gets the wp_subscribers of this SubAccountUpdatePlanRequestCredits.  # noqa: E501

        Number of Push credits, possible value is 0 and -1 | available in ENT-v2 only  # noqa: E501

        :return: The wp_subscribers of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :rtype: int
        """
        return self._wp_subscribers

    @wp_subscribers.setter
    def wp_subscribers(self, wp_subscribers):
        """Sets the wp_subscribers of this SubAccountUpdatePlanRequestCredits.

        Number of Push credits, possible value is 0 and -1 | available in ENT-v2 only  # noqa: E501

        :param wp_subscribers: The wp_subscribers of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :type: int
        """

        self._wp_subscribers = wp_subscribers

    @property
    def external_feeds(self):
        """Gets the external_feeds of this SubAccountUpdatePlanRequestCredits.  # noqa: E501

        Number of externalFeeds credits, possible values are 0 or 1 |available in ENTv2 only  # noqa: E501

        :return: The external_feeds of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :rtype: float
        """
        return self._external_feeds

    @external_feeds.setter
    def external_feeds(self, external_feeds):
        """Sets the external_feeds of this SubAccountUpdatePlanRequestCredits.

        Number of externalFeeds credits, possible values are 0 or 1 |available in ENTv2 only  # noqa: E501

        :param external_feeds: The external_feeds of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :type: float
        """

        self._external_feeds = external_feeds

    @property
    def whatsapp(self):
        """Gets the whatsapp of this SubAccountUpdatePlanRequestCredits.  # noqa: E501

        Number of whatsapp credits | Pass the value -1 for unlimited whatsapp in ENTv2 only  # noqa: E501

        :return: The whatsapp of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :rtype: float
        """
        return self._whatsapp

    @whatsapp.setter
    def whatsapp(self, whatsapp):
        """Sets the whatsapp of this SubAccountUpdatePlanRequestCredits.

        Number of whatsapp credits | Pass the value -1 for unlimited whatsapp in ENTv2 only  # noqa: E501

        :param whatsapp: The whatsapp of this SubAccountUpdatePlanRequestCredits.  # noqa: E501
        :type: float
        """

        self._whatsapp = whatsapp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubAccountUpdatePlanRequestCredits, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubAccountUpdatePlanRequestCredits):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
