# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Subscription(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contact_id': 'int',
        'created_at': 'str',
        'loyalty_program_id': 'str',
        'loyalty_subscription_id': 'str',
        'organization_id': 'int',
        'updated_at': 'str',
        'version_id': 'int'
    }

    attribute_map = {
        'contact_id': 'contactId',
        'created_at': 'createdAt',
        'loyalty_program_id': 'loyaltyProgramId',
        'loyalty_subscription_id': 'loyaltySubscriptionId',
        'organization_id': 'organizationId',
        'updated_at': 'updatedAt',
        'version_id': 'versionId'
    }

    def __init__(self, contact_id=None, created_at=None, loyalty_program_id=None, loyalty_subscription_id=None, organization_id=None, updated_at=None, version_id=None):  # noqa: E501
        """Subscription - a model defined in Swagger"""  # noqa: E501

        self._contact_id = None
        self._created_at = None
        self._loyalty_program_id = None
        self._loyalty_subscription_id = None
        self._organization_id = None
        self._updated_at = None
        self._version_id = None
        self.discriminator = None

        if contact_id is not None:
            self.contact_id = contact_id
        if created_at is not None:
            self.created_at = created_at
        if loyalty_program_id is not None:
            self.loyalty_program_id = loyalty_program_id
        if loyalty_subscription_id is not None:
            self.loyalty_subscription_id = loyalty_subscription_id
        if organization_id is not None:
            self.organization_id = organization_id
        if updated_at is not None:
            self.updated_at = updated_at
        if version_id is not None:
            self.version_id = version_id

    @property
    def contact_id(self):
        """Gets the contact_id of this Subscription.  # noqa: E501

        Unique identifier of the contact.  # noqa: E501

        :return: The contact_id of this Subscription.  # noqa: E501
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this Subscription.

        Unique identifier of the contact.  # noqa: E501

        :param contact_id: The contact_id of this Subscription.  # noqa: E501
        :type: int
        """

        self._contact_id = contact_id

    @property
    def created_at(self):
        """Gets the created_at of this Subscription.  # noqa: E501

        Timestamp when the subscription was created.  # noqa: E501

        :return: The created_at of this Subscription.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Subscription.

        Timestamp when the subscription was created.  # noqa: E501

        :param created_at: The created_at of this Subscription.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def loyalty_program_id(self):
        """Gets the loyalty_program_id of this Subscription.  # noqa: E501

        Unique identifier of the loyalty program.  # noqa: E501

        :return: The loyalty_program_id of this Subscription.  # noqa: E501
        :rtype: str
        """
        return self._loyalty_program_id

    @loyalty_program_id.setter
    def loyalty_program_id(self, loyalty_program_id):
        """Sets the loyalty_program_id of this Subscription.

        Unique identifier of the loyalty program.  # noqa: E501

        :param loyalty_program_id: The loyalty_program_id of this Subscription.  # noqa: E501
        :type: str
        """

        self._loyalty_program_id = loyalty_program_id

    @property
    def loyalty_subscription_id(self):
        """Gets the loyalty_subscription_id of this Subscription.  # noqa: E501

        Unique identifier of the subscription.  # noqa: E501

        :return: The loyalty_subscription_id of this Subscription.  # noqa: E501
        :rtype: str
        """
        return self._loyalty_subscription_id

    @loyalty_subscription_id.setter
    def loyalty_subscription_id(self, loyalty_subscription_id):
        """Sets the loyalty_subscription_id of this Subscription.

        Unique identifier of the subscription.  # noqa: E501

        :param loyalty_subscription_id: The loyalty_subscription_id of this Subscription.  # noqa: E501
        :type: str
        """

        self._loyalty_subscription_id = loyalty_subscription_id

    @property
    def organization_id(self):
        """Gets the organization_id of this Subscription.  # noqa: E501

        Unique identifier of the organization.  # noqa: E501

        :return: The organization_id of this Subscription.  # noqa: E501
        :rtype: int
        """
        return self._organization_id

    @organization_id.setter
    def organization_id(self, organization_id):
        """Sets the organization_id of this Subscription.

        Unique identifier of the organization.  # noqa: E501

        :param organization_id: The organization_id of this Subscription.  # noqa: E501
        :type: int
        """

        self._organization_id = organization_id

    @property
    def updated_at(self):
        """Gets the updated_at of this Subscription.  # noqa: E501

        Timestamp when the subscription was last updated.  # noqa: E501

        :return: The updated_at of this Subscription.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Subscription.

        Timestamp when the subscription was last updated.  # noqa: E501

        :param updated_at: The updated_at of this Subscription.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def version_id(self):
        """Gets the version_id of this Subscription.  # noqa: E501

        Version number of the subscription.  # noqa: E501

        :return: The version_id of this Subscription.  # noqa: E501
        :rtype: int
        """
        return self._version_id

    @version_id.setter
    def version_id(self, version_id):
        """Sets the version_id of this Subscription.

        Version number of the subscription.  # noqa: E501

        :param version_id: The version_id of this Subscription.  # noqa: E501
        :type: int
        """

        self._version_id = version_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Subscription, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Subscription):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
