# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SubscriptionBalances(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'balances': 'list[SubscriptionAggregateBalance]',
        'contact_id': 'int',
        'loyalty_program_id': 'str'
    }

    attribute_map = {
        'balances': 'balances',
        'contact_id': 'contactId',
        'loyalty_program_id': 'loyaltyProgramId'
    }

    def __init__(self, balances=None, contact_id=None, loyalty_program_id=None):  # noqa: E501
        """SubscriptionBalances - a model defined in Swagger"""  # noqa: E501

        self._balances = None
        self._contact_id = None
        self._loyalty_program_id = None
        self.discriminator = None

        if balances is not None:
            self.balances = balances
        if contact_id is not None:
            self.contact_id = contact_id
        if loyalty_program_id is not None:
            self.loyalty_program_id = loyalty_program_id

    @property
    def balances(self):
        """Gets the balances of this SubscriptionBalances.  # noqa: E501

        List of balance details associated with the contact.  # noqa: E501

        :return: The balances of this SubscriptionBalances.  # noqa: E501
        :rtype: list[SubscriptionAggregateBalance]
        """
        return self._balances

    @balances.setter
    def balances(self, balances):
        """Sets the balances of this SubscriptionBalances.

        List of balance details associated with the contact.  # noqa: E501

        :param balances: The balances of this SubscriptionBalances.  # noqa: E501
        :type: list[SubscriptionAggregateBalance]
        """

        self._balances = balances

    @property
    def contact_id(self):
        """Gets the contact_id of this SubscriptionBalances.  # noqa: E501

        Unique identifier of the contact.  # noqa: E501

        :return: The contact_id of this SubscriptionBalances.  # noqa: E501
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this SubscriptionBalances.

        Unique identifier of the contact.  # noqa: E501

        :param contact_id: The contact_id of this SubscriptionBalances.  # noqa: E501
        :type: int
        """

        self._contact_id = contact_id

    @property
    def loyalty_program_id(self):
        """Gets the loyalty_program_id of this SubscriptionBalances.  # noqa: E501

        Unique identifier of the loyalty program.  # noqa: E501

        :return: The loyalty_program_id of this SubscriptionBalances.  # noqa: E501
        :rtype: str
        """
        return self._loyalty_program_id

    @loyalty_program_id.setter
    def loyalty_program_id(self, loyalty_program_id):
        """Sets the loyalty_program_id of this SubscriptionBalances.

        Unique identifier of the loyalty program.  # noqa: E501

        :param loyalty_program_id: The loyalty_program_id of this SubscriptionBalances.  # noqa: E501
        :type: str
        """

        self._loyalty_program_id = loyalty_program_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubscriptionBalances, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubscriptionBalances):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
