# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SubscriptionTier(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contact_id': 'int',
        'created_at': 'str',
        'group_id': 'str',
        'loyalty_program_id': 'str',
        'meta': 'dict(str, object)',
        'tier_id': 'str',
        'updated_at': 'str'
    }

    attribute_map = {
        'contact_id': 'contactId',
        'created_at': 'createdAt',
        'group_id': 'groupId',
        'loyalty_program_id': 'loyaltyProgramId',
        'meta': 'meta',
        'tier_id': 'tierId',
        'updated_at': 'updatedAt'
    }

    def __init__(self, contact_id=None, created_at=None, group_id=None, loyalty_program_id=None, meta=None, tier_id=None, updated_at=None):  # noqa: E501
        """SubscriptionTier - a model defined in Swagger"""  # noqa: E501

        self._contact_id = None
        self._created_at = None
        self._group_id = None
        self._loyalty_program_id = None
        self._meta = None
        self._tier_id = None
        self._updated_at = None
        self.discriminator = None

        if contact_id is not None:
            self.contact_id = contact_id
        if created_at is not None:
            self.created_at = created_at
        if group_id is not None:
            self.group_id = group_id
        if loyalty_program_id is not None:
            self.loyalty_program_id = loyalty_program_id
        if meta is not None:
            self.meta = meta
        if tier_id is not None:
            self.tier_id = tier_id
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def contact_id(self):
        """Gets the contact_id of this SubscriptionTier.  # noqa: E501

        Unique identifier of the contact.  # noqa: E501

        :return: The contact_id of this SubscriptionTier.  # noqa: E501
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this SubscriptionTier.

        Unique identifier of the contact.  # noqa: E501

        :param contact_id: The contact_id of this SubscriptionTier.  # noqa: E501
        :type: int
        """

        self._contact_id = contact_id

    @property
    def created_at(self):
        """Gets the created_at of this SubscriptionTier.  # noqa: E501

        Timestamp when the tier was assigned.  # noqa: E501

        :return: The created_at of this SubscriptionTier.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this SubscriptionTier.

        Timestamp when the tier was assigned.  # noqa: E501

        :param created_at: The created_at of this SubscriptionTier.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def group_id(self):
        """Gets the group_id of this SubscriptionTier.  # noqa: E501

        Unique identifier of the group associated with the tier.  # noqa: E501

        :return: The group_id of this SubscriptionTier.  # noqa: E501
        :rtype: str
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """Sets the group_id of this SubscriptionTier.

        Unique identifier of the group associated with the tier.  # noqa: E501

        :param group_id: The group_id of this SubscriptionTier.  # noqa: E501
        :type: str
        """

        self._group_id = group_id

    @property
    def loyalty_program_id(self):
        """Gets the loyalty_program_id of this SubscriptionTier.  # noqa: E501

        Unique identifier of the loyalty program.  # noqa: E501

        :return: The loyalty_program_id of this SubscriptionTier.  # noqa: E501
        :rtype: str
        """
        return self._loyalty_program_id

    @loyalty_program_id.setter
    def loyalty_program_id(self, loyalty_program_id):
        """Sets the loyalty_program_id of this SubscriptionTier.

        Unique identifier of the loyalty program.  # noqa: E501

        :param loyalty_program_id: The loyalty_program_id of this SubscriptionTier.  # noqa: E501
        :type: str
        """

        self._loyalty_program_id = loyalty_program_id

    @property
    def meta(self):
        """Gets the meta of this SubscriptionTier.  # noqa: E501

        Additional metadata related to the tier.  # noqa: E501

        :return: The meta of this SubscriptionTier.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this SubscriptionTier.

        Additional metadata related to the tier.  # noqa: E501

        :param meta: The meta of this SubscriptionTier.  # noqa: E501
        :type: dict(str, object)
        """

        self._meta = meta

    @property
    def tier_id(self):
        """Gets the tier_id of this SubscriptionTier.  # noqa: E501

        Unique identifier of the tier.  # noqa: E501

        :return: The tier_id of this SubscriptionTier.  # noqa: E501
        :rtype: str
        """
        return self._tier_id

    @tier_id.setter
    def tier_id(self, tier_id):
        """Sets the tier_id of this SubscriptionTier.

        Unique identifier of the tier.  # noqa: E501

        :param tier_id: The tier_id of this SubscriptionTier.  # noqa: E501
        :type: str
        """

        self._tier_id = tier_id

    @property
    def updated_at(self):
        """Gets the updated_at of this SubscriptionTier.  # noqa: E501

        Timestamp when the tier was last updated  # noqa: E501

        :return: The updated_at of this SubscriptionTier.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this SubscriptionTier.

        Timestamp when the tier was last updated  # noqa: E501

        :param updated_at: The updated_at of this SubscriptionTier.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubscriptionTier, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubscriptionTier):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
