# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class TierAccessConditions(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'balance_definition_id': 'str',
        'minimum_value': 'int',
        'created_at': 'datetime',
        'updated_at': 'datetime'
    }

    attribute_map = {
        'balance_definition_id': 'balanceDefinitionId',
        'minimum_value': 'minimumValue',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt'
    }

    def __init__(self, balance_definition_id=None, minimum_value=None, created_at=None, updated_at=None):  # noqa: E501
        """TierAccessConditions - a model defined in Swagger"""  # noqa: E501

        self._balance_definition_id = None
        self._minimum_value = None
        self._created_at = None
        self._updated_at = None
        self.discriminator = None

        if balance_definition_id is not None:
            self.balance_definition_id = balance_definition_id
        if minimum_value is not None:
            self.minimum_value = minimum_value
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def balance_definition_id(self):
        """Gets the balance_definition_id of this TierAccessConditions.  # noqa: E501

        Balance definition identifier  # noqa: E501

        :return: The balance_definition_id of this TierAccessConditions.  # noqa: E501
        :rtype: str
        """
        return self._balance_definition_id

    @balance_definition_id.setter
    def balance_definition_id(self, balance_definition_id):
        """Sets the balance_definition_id of this TierAccessConditions.

        Balance definition identifier  # noqa: E501

        :param balance_definition_id: The balance_definition_id of this TierAccessConditions.  # noqa: E501
        :type: str
        """

        self._balance_definition_id = balance_definition_id

    @property
    def minimum_value(self):
        """Gets the minimum_value of this TierAccessConditions.  # noqa: E501

        Minimum value required to access this tier  # noqa: E501

        :return: The minimum_value of this TierAccessConditions.  # noqa: E501
        :rtype: int
        """
        return self._minimum_value

    @minimum_value.setter
    def minimum_value(self, minimum_value):
        """Sets the minimum_value of this TierAccessConditions.

        Minimum value required to access this tier  # noqa: E501

        :param minimum_value: The minimum_value of this TierAccessConditions.  # noqa: E501
        :type: int
        """

        self._minimum_value = minimum_value

    @property
    def created_at(self):
        """Gets the created_at of this TierAccessConditions.  # noqa: E501


        :return: The created_at of this TierAccessConditions.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this TierAccessConditions.


        :param created_at: The created_at of this TierAccessConditions.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this TierAccessConditions.  # noqa: E501


        :return: The updated_at of this TierAccessConditions.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this TierAccessConditions.


        :param updated_at: The updated_at of this TierAccessConditions.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TierAccessConditions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TierAccessConditions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
