# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class UpdateEmailCampaignEmailExpirationDate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'duration': 'float',
        'unit': 'str'
    }

    attribute_map = {
        'duration': 'duration',
        'unit': 'unit'
    }

    def __init__(self, duration=None, unit=None):  # noqa: E501
        """UpdateEmailCampaignEmailExpirationDate - a model defined in Swagger"""  # noqa: E501

        self._duration = None
        self._unit = None
        self.discriminator = None

        if duration is not None:
            self.duration = duration
        if unit is not None:
            self.unit = unit

    @property
    def duration(self):
        """Gets the duration of this UpdateEmailCampaignEmailExpirationDate.  # noqa: E501

        Duration of the email expiry. maximum duration can be 3600 days or 480 weeks or 120 months.  # noqa: E501

        :return: The duration of this UpdateEmailCampaignEmailExpirationDate.  # noqa: E501
        :rtype: float
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """Sets the duration of this UpdateEmailCampaignEmailExpirationDate.

        Duration of the email expiry. maximum duration can be 3600 days or 480 weeks or 120 months.  # noqa: E501

        :param duration: The duration of this UpdateEmailCampaignEmailExpirationDate.  # noqa: E501
        :type: float
        """
        if duration is not None and duration > 3600:  # noqa: E501
            raise ValueError("Invalid value for `duration`, must be a value less than or equal to `3600`")  # noqa: E501
        if duration is not None and duration < 1:  # noqa: E501
            raise ValueError("Invalid value for `duration`, must be a value greater than or equal to `1`")  # noqa: E501

        self._duration = duration

    @property
    def unit(self):
        """Gets the unit of this UpdateEmailCampaignEmailExpirationDate.  # noqa: E501

        Date-time of the email expiration  # noqa: E501

        :return: The unit of this UpdateEmailCampaignEmailExpirationDate.  # noqa: E501
        :rtype: str
        """
        return self._unit

    @unit.setter
    def unit(self, unit):
        """Sets the unit of this UpdateEmailCampaignEmailExpirationDate.

        Date-time of the email expiration  # noqa: E501

        :param unit: The unit of this UpdateEmailCampaignEmailExpirationDate.  # noqa: E501
        :type: str
        """
        allowed_values = ["days", "weeks", "months"]  # noqa: E501
        if unit not in allowed_values:
            raise ValueError(
                "Invalid value for `unit` ({0}), must be one of {1}"  # noqa: E501
                .format(unit, allowed_values)
            )

        self._unit = unit

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateEmailCampaignEmailExpirationDate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateEmailCampaignEmailExpirationDate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
