# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CreateLoyaltyProgramPayload(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'document_id': 'str',
        'meta': 'dict(str, object)',
        'name': 'str'
    }

    attribute_map = {
        'description': 'description',
        'document_id': 'documentId',
        'meta': 'meta',
        'name': 'name'
    }

    def __init__(self, description=None, document_id=None, meta=None, name=None):  # noqa: E501
        """CreateLoyaltyProgramPayload - a model defined in Swagger"""  # noqa: E501

        self._description = None
        self._document_id = None
        self._meta = None
        self._name = None
        self.discriminator = None

        if description is not None:
            self.description = description
        if document_id is not None:
            self.document_id = document_id
        if meta is not None:
            self.meta = meta
        self.name = name

    @property
    def description(self):
        """Gets the description of this CreateLoyaltyProgramPayload.  # noqa: E501

        Optional description of the loyalty program (max 256 chars).  # noqa: E501

        :return: The description of this CreateLoyaltyProgramPayload.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CreateLoyaltyProgramPayload.

        Optional description of the loyalty program (max 256 chars).  # noqa: E501

        :param description: The description of this CreateLoyaltyProgramPayload.  # noqa: E501
        :type: str
        """
        if description is not None and len(description) > 256:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `256`")  # noqa: E501

        self._description = description

    @property
    def document_id(self):
        """Gets the document_id of this CreateLoyaltyProgramPayload.  # noqa: E501

        Optional unique document ID.  # noqa: E501

        :return: The document_id of this CreateLoyaltyProgramPayload.  # noqa: E501
        :rtype: str
        """
        return self._document_id

    @document_id.setter
    def document_id(self, document_id):
        """Sets the document_id of this CreateLoyaltyProgramPayload.

        Optional unique document ID.  # noqa: E501

        :param document_id: The document_id of this CreateLoyaltyProgramPayload.  # noqa: E501
        :type: str
        """

        self._document_id = document_id

    @property
    def meta(self):
        """Gets the meta of this CreateLoyaltyProgramPayload.  # noqa: E501

        Optional metadata related to the loyalty program.  # noqa: E501

        :return: The meta of this CreateLoyaltyProgramPayload.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this CreateLoyaltyProgramPayload.

        Optional metadata related to the loyalty program.  # noqa: E501

        :param meta: The meta of this CreateLoyaltyProgramPayload.  # noqa: E501
        :type: dict(str, object)
        """

        self._meta = meta

    @property
    def name(self):
        """Gets the name of this CreateLoyaltyProgramPayload.  # noqa: E501

        Required name of the loyalty program (max 128 chars).  # noqa: E501

        :return: The name of this CreateLoyaltyProgramPayload.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateLoyaltyProgramPayload.

        Required name of the loyalty program (max 128 chars).  # noqa: E501

        :param name: The name of this CreateLoyaltyProgramPayload.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 128:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `128`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateLoyaltyProgramPayload, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateLoyaltyProgramPayload):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
