# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MainCreateRedeemPayload(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'attributed_reward_id': 'str',
        'code': 'str',
        'contact_id': 'int',
        'loyalty_subscription_id': 'str',
        'meta': 'dict(str, object)',
        'order': 'object',
        'reward_id': 'str',
        'ttl': 'int'
    }

    attribute_map = {
        'attributed_reward_id': 'attributedRewardId',
        'code': 'code',
        'contact_id': 'contactId',
        'loyalty_subscription_id': 'loyaltySubscriptionId',
        'meta': 'meta',
        'order': 'order',
        'reward_id': 'rewardId',
        'ttl': 'ttl'
    }

    def __init__(self, attributed_reward_id=None, code=None, contact_id=None, loyalty_subscription_id=None, meta=None, order=None, reward_id=None, ttl=None):  # noqa: E501
        """MainCreateRedeemPayload - a model defined in Swagger"""  # noqa: E501

        self._attributed_reward_id = None
        self._code = None
        self._contact_id = None
        self._loyalty_subscription_id = None
        self._meta = None
        self._order = None
        self._reward_id = None
        self._ttl = None
        self.discriminator = None

        if attributed_reward_id is not None:
            self.attributed_reward_id = attributed_reward_id
        if code is not None:
            self.code = code
        if contact_id is not None:
            self.contact_id = contact_id
        if loyalty_subscription_id is not None:
            self.loyalty_subscription_id = loyalty_subscription_id
        if meta is not None:
            self.meta = meta
        if order is not None:
            self.order = order
        if reward_id is not None:
            self.reward_id = reward_id
        if ttl is not None:
            self.ttl = ttl

    @property
    def attributed_reward_id(self):
        """Gets the attributed_reward_id of this MainCreateRedeemPayload.  # noqa: E501

        Unique identifier for the attributed reward  # noqa: E501

        :return: The attributed_reward_id of this MainCreateRedeemPayload.  # noqa: E501
        :rtype: str
        """
        return self._attributed_reward_id

    @attributed_reward_id.setter
    def attributed_reward_id(self, attributed_reward_id):
        """Sets the attributed_reward_id of this MainCreateRedeemPayload.

        Unique identifier for the attributed reward  # noqa: E501

        :param attributed_reward_id: The attributed_reward_id of this MainCreateRedeemPayload.  # noqa: E501
        :type: str
        """

        self._attributed_reward_id = attributed_reward_id

    @property
    def code(self):
        """Gets the code of this MainCreateRedeemPayload.  # noqa: E501

        Redemption code for the reward  # noqa: E501

        :return: The code of this MainCreateRedeemPayload.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this MainCreateRedeemPayload.

        Redemption code for the reward  # noqa: E501

        :param code: The code of this MainCreateRedeemPayload.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def contact_id(self):
        """Gets the contact_id of this MainCreateRedeemPayload.  # noqa: E501

        Unique identifier for the contact  # noqa: E501

        :return: The contact_id of this MainCreateRedeemPayload.  # noqa: E501
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this MainCreateRedeemPayload.

        Unique identifier for the contact  # noqa: E501

        :param contact_id: The contact_id of this MainCreateRedeemPayload.  # noqa: E501
        :type: int
        """
        if contact_id is not None and contact_id < 1:  # noqa: E501
            raise ValueError("Invalid value for `contact_id`, must be a value greater than or equal to `1`")  # noqa: E501

        self._contact_id = contact_id

    @property
    def loyalty_subscription_id(self):
        """Gets the loyalty_subscription_id of this MainCreateRedeemPayload.  # noqa: E501

        Identifier for the loyalty subscription  # noqa: E501

        :return: The loyalty_subscription_id of this MainCreateRedeemPayload.  # noqa: E501
        :rtype: str
        """
        return self._loyalty_subscription_id

    @loyalty_subscription_id.setter
    def loyalty_subscription_id(self, loyalty_subscription_id):
        """Sets the loyalty_subscription_id of this MainCreateRedeemPayload.

        Identifier for the loyalty subscription  # noqa: E501

        :param loyalty_subscription_id: The loyalty_subscription_id of this MainCreateRedeemPayload.  # noqa: E501
        :type: str
        """

        self._loyalty_subscription_id = loyalty_subscription_id

    @property
    def meta(self):
        """Gets the meta of this MainCreateRedeemPayload.  # noqa: E501

        Additional metadata associated with the redeem request  # noqa: E501

        :return: The meta of this MainCreateRedeemPayload.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this MainCreateRedeemPayload.

        Additional metadata associated with the redeem request  # noqa: E501

        :param meta: The meta of this MainCreateRedeemPayload.  # noqa: E501
        :type: dict(str, object)
        """

        self._meta = meta

    @property
    def order(self):
        """Gets the order of this MainCreateRedeemPayload.  # noqa: E501

        Order details for the redemption  # noqa: E501

        :return: The order of this MainCreateRedeemPayload.  # noqa: E501
        :rtype: object
        """
        return self._order

    @order.setter
    def order(self, order):
        """Sets the order of this MainCreateRedeemPayload.

        Order details for the redemption  # noqa: E501

        :param order: The order of this MainCreateRedeemPayload.  # noqa: E501
        :type: object
        """

        self._order = order

    @property
    def reward_id(self):
        """Gets the reward_id of this MainCreateRedeemPayload.  # noqa: E501

        Unique identifier for the reward  # noqa: E501

        :return: The reward_id of this MainCreateRedeemPayload.  # noqa: E501
        :rtype: str
        """
        return self._reward_id

    @reward_id.setter
    def reward_id(self, reward_id):
        """Sets the reward_id of this MainCreateRedeemPayload.

        Unique identifier for the reward  # noqa: E501

        :param reward_id: The reward_id of this MainCreateRedeemPayload.  # noqa: E501
        :type: str
        """

        self._reward_id = reward_id

    @property
    def ttl(self):
        """Gets the ttl of this MainCreateRedeemPayload.  # noqa: E501

        Time to live in seconds for the redemption request  # noqa: E501

        :return: The ttl of this MainCreateRedeemPayload.  # noqa: E501
        :rtype: int
        """
        return self._ttl

    @ttl.setter
    def ttl(self, ttl):
        """Sets the ttl of this MainCreateRedeemPayload.

        Time to live in seconds for the redemption request  # noqa: E501

        :param ttl: The ttl of this MainCreateRedeemPayload.  # noqa: E501
        :type: int
        """
        if ttl is not None and ttl < 0:  # noqa: E501
            raise ValueError("Invalid value for `ttl`, must be a value greater than or equal to `0`")  # noqa: E501

        self._ttl = ttl

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MainCreateRedeemPayload, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MainCreateRedeemPayload):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
