# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MainCreateRewardPayload(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'public_description': 'str',
        'public_image': 'str',
        'public_name': 'str'
    }

    attribute_map = {
        'name': 'name',
        'public_description': 'publicDescription',
        'public_image': 'publicImage',
        'public_name': 'publicName'
    }

    def __init__(self, name=None, public_description=None, public_image=None, public_name=None):  # noqa: E501
        """MainCreateRewardPayload - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._public_description = None
        self._public_image = None
        self._public_name = None
        self.discriminator = None

        self.name = name
        if public_description is not None:
            self.public_description = public_description
        if public_image is not None:
            self.public_image = public_image
        if public_name is not None:
            self.public_name = public_name

    @property
    def name(self):
        """Gets the name of this MainCreateRewardPayload.  # noqa: E501

        Internal name of the reward  # noqa: E501

        :return: The name of this MainCreateRewardPayload.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this MainCreateRewardPayload.

        Internal name of the reward  # noqa: E501

        :param name: The name of this MainCreateRewardPayload.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 128:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `128`")  # noqa: E501

        self._name = name

    @property
    def public_description(self):
        """Gets the public_description of this MainCreateRewardPayload.  # noqa: E501

        Public facing description of the reward  # noqa: E501

        :return: The public_description of this MainCreateRewardPayload.  # noqa: E501
        :rtype: str
        """
        return self._public_description

    @public_description.setter
    def public_description(self, public_description):
        """Sets the public_description of this MainCreateRewardPayload.

        Public facing description of the reward  # noqa: E501

        :param public_description: The public_description of this MainCreateRewardPayload.  # noqa: E501
        :type: str
        """
        if public_description is not None and len(public_description) > 128:
            raise ValueError("Invalid value for `public_description`, length must be less than or equal to `128`")  # noqa: E501

        self._public_description = public_description

    @property
    def public_image(self):
        """Gets the public_image of this MainCreateRewardPayload.  # noqa: E501

        URL of the public image for the reward  # noqa: E501

        :return: The public_image of this MainCreateRewardPayload.  # noqa: E501
        :rtype: str
        """
        return self._public_image

    @public_image.setter
    def public_image(self, public_image):
        """Sets the public_image of this MainCreateRewardPayload.

        URL of the public image for the reward  # noqa: E501

        :param public_image: The public_image of this MainCreateRewardPayload.  # noqa: E501
        :type: str
        """

        self._public_image = public_image

    @property
    def public_name(self):
        """Gets the public_name of this MainCreateRewardPayload.  # noqa: E501

        Public facing name of the reward  # noqa: E501

        :return: The public_name of this MainCreateRewardPayload.  # noqa: E501
        :rtype: str
        """
        return self._public_name

    @public_name.setter
    def public_name(self, public_name):
        """Sets the public_name of this MainCreateRewardPayload.

        Public facing name of the reward  # noqa: E501

        :param public_name: The public_name of this MainCreateRewardPayload.  # noqa: E501
        :type: str
        """
        if public_name is not None and len(public_name) > 128:
            raise ValueError("Invalid value for `public_name`, length must be less than or equal to `128`")  # noqa: E501

        self._public_name = public_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MainCreateRewardPayload, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MainCreateRewardPayload):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
